#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# Dieses Dokument ist in der Zusammenarbeit von Informatikreferendaren und
# ehemaligen Informatikreferendaren der Studienseminare (heute ZfsL) Arnsberg,
# Hamm und Solingen entstanden.
#
# Das Dokument steht unter der Lizenz: Creative Commons by-nc-sa Version 4.0
# http://creativecommons.org/licenses/by-nc-sa/4.0/deed.de
#
# Nach dieser Lizenz darf das Dokument beliebig kopiert und bearbeitet werden,
# sofern das Folgeprodukt wiederum unter gleichen Lizenzbedingungen vertrieben
# und auf die ursprünglichen Urheber verwiesen wird.
# Eine kommerzielle Nutzung ist ausdrücklich ausgeschlossen.
#
# Die Namensnennung durch einen Verweis und die Lizenzangabe der ursprünglichen
# Urheber auf den Materialien für Schülerinnen und Schüler ist erforderlich.
#
# Die Sammlung der Dokumente steht unter
# http://ddi.uni-wuppertal.de/material/materialsammlung/
# zur Verfügung.
#
# Weitere Lizenz: GPL V3.0
# Siehe http://www.gnu.org/licenses/gpl-3.0.html
#
# $Id: basketballturnier-unvollstaendig.py 582 2014-04-19 19:19:24Z pieper $
#
# Umsetzung des "Basketball-Problems" in der Programmiersprache Python.
# Die mit "# ..." gekennzeichneten Stellen sind zu ergänzen.

from datenstrukturen import Liste
from tabellensortierer import TabellenSortierer

class BasketballTurnier:
    def __init__(self, datum, beginn, ende, veranstalter):
        self.datum = datum
        self.beginn = beginn
        self.ende = ende
        self.veranstalter = veranstalter
        self.mannschaften = Liste()
        self.tabelle = Tabelle()
    def gibDatum(self):
        return self.datum
    def gibBeginn(self):
        return self.beginn
    def gibEnde(self):
        return self.ende
    def gibVeranstalter(self):
        return self.veranstalter
    def gibTabelle(self):
        return self.tabelle
         
    def spielEintragen(self, spiel):
        # ... (mehrere Zeilen Code)
	pass


    def gibSieger(self):
        return # ...
    
class TabellenEintrag:
    def __init__(self, mannschaft):
        # ... (mehrere Zeilen Code)
        self.spiele =   0
        self.siege  =   0
        self.punktDiff      =   0   
        self.punktErzielt   =   0
        self.mannschaft =   mannschaft
    def gibMannschaft(self):
        return self.mannschaft
    def gibSpiele(self):
        return self.spiele
    def gibSiege(self):
        return self.siege
    def gibPunktDiff(self):
        return self.punktDiff
    def gibPunktErzielt(self):
        return self.punktErzielt
    
    def aktualisieren(self, siege, punktDiff, punktErzielt):
        # ... (mehrere Zeilen Code)
	pass
         
    def __str__(self):
        return self.mannschaft.gibNamen().ljust(20) + " Spiele: " + str(self.spiele) + ", Siege: " + str(self.siege).rjust(2) + ", Diff: " + str(self.punktDiff).rjust(3) + ", Punkte: " + str(self.punktErzielt).rjust(3)
    
class Tabelle:
    def __init__(self):
        self.eintraege = Liste()
    def neueMannschaftAufnehmen(self, mannschaft):
        self.eintraege.haengeAn(TabellenEintrag(mannschaft))      
    def ergebnisEintragen(self, spiel):
        # ... (mehrere Zeilen Code)
        position    =   0
        while(position < self.eintraege.gibLaenge()):
            if(self.eintraege.gibElementAnPosition(position) == spiel.gibSieger()):
		pass
                
            elif():
		pass
            
            position = position+1
        spiel.gibSieger()
    def sortiereEintraege(self):
        sortierer = TabellenSortierer()
        self.eintraege = sortierer.sortiere(self.eintraege)

    def ausgabe(self):
        self.sortiereEintraege()
        zaehler = 0
        while zaehler < self.eintraege.gibLaenge():
            print ( str(self.eintraege.gibElementAnPosition(zaehler)) )
            zaehler = zaehler + 1

    def gibTabellenFuehrer(self):
        self.sortiereEintraege()
        return # ...
    
class BasketballSpiel:
    def __init__(self, beginn, ende, ort, mannschaftA, mannschaftB, punkteA, punkteB):
        self.beginn = beginn
        self.ende = ende
        self.ort = ort
        self.mannschaftA = mannschaftA
        self.mannschaftB = mannschaftB
        self.punkteA = punkteA
        self.punkteB = punkteB
    def gibBeginn(self):
        return self.beginn
    def gibEnde(self):
        return self.ende
    def gibOrt(self):
        return self.ort
    def gibMannschaftA(self):
        return self.mannschaftA
    def gibMannschaftB(self):
        return self.mannschaftB
    
    def gibSieger(self):
        # ... (mehrere Zeilen Code; was gibt man bei einem Unentschieden zurück?)
        if(self.punkteA > self.punkteB):
            return self.mannschaftA
        elif(self.punkteA < self.punkteB):
            return self.mannschaftB
        else:
            return None
    def gibVerlierer(self):
        # ... (mehrere Zeilen Code)
        if(self.punkteA < self.punkteB):
            return self.mannschaftA
        elif(self.punkteA > self.punkteB):
            return self.mannschaftB
        else:
            return None
    def gibPunkteSieger(self):
        # ... (mehrere Zeilen Code)
        if(self.punkteA > self.punkteB):
            return self.punkteA
        elif(self.punkteA < self.punkteB):
            return self.punkteB
        else:
            return None
    def gibPunkteVerlierer(self):
        # ... (mehrere Zeilen Code)
        if(self.punkteA < self.punkteB):
            return self.punkteA
        elif(self.punkteA > self.punkteB):
            return self.punkteB
        else:
            return None
        
class Mannschaft:
    def __init__(self, name, kurs, trikotfarbe):
        self.name = name
        self.kurs = kurs
        self.trikotfarbe = trikotfarbe
    def gibNamen(self):
        return self.name
    def gibKurs(self):
        return self.kurs
    def gibTrikotfarbe(self):
        return self.trikotfarbe
    def setzeNamen(self, neuerName):
        self.name = neuerName
    def setzeTrikotfarbe(self, neueFarbe):
        self.trikotfarbe = neueFarbe
    
class Sporthalle:
    def __init__(self, name, standort):
        self.name = name
        self.standort = standort
    def gibNamen(self):
        return self.name
    def gibStandort(self):
        return self.standort



    
basketballTurnierSGS = BasketballTurnier("16.08.2037", "9:30", "12:30", "Städtisches Gymnasium Selm")

dieKaengurus = Mannschaft("Die Kängurus", "11d2", "gruen")
crazyFrogs = Mannschaft("Crazy Frogs", "11d1", "blau")
dieUeberflieger = Mannschaft("Die Überflieger", "11d3", "gelb")
dieNowitzkis = Mannschaft("Die Nowitzkis", "11d4", "grau")

halleA = Sporthalle("Halle A", "Altbau")
halleB = Sporthalle("Halle B", "Neubau")

basketballTurnierSGS.spielEintragen(BasketballSpiel("09:45", "10:15", halleA, dieKaengurus, dieNowitzkis, 32, 20))
basketballTurnierSGS.spielEintragen(BasketballSpiel("10:00", "10:30", halleB, dieUeberflieger, crazyFrogs, 24, 23))
basketballTurnierSGS.spielEintragen(BasketballSpiel("10:45", "11:15", halleA, dieKaengurus, dieUeberflieger, 31, 22))
basketballTurnierSGS.spielEintragen(BasketballSpiel("11:00", "11:30", halleB, dieNowitzkis, crazyFrogs, 15, 33))
basketballTurnierSGS.spielEintragen(BasketballSpiel("11:45", "12:15", halleA, dieKaengurus, crazyFrogs, 26, 31))
basketballTurnierSGS.spielEintragen(BasketballSpiel("12:00", "12:30", halleB, dieNowitzkis, dieUeberflieger, 27, 27))
 


print "Gesamtsieger: ", # ...
basketballTurnierSGS.gibTabelle().ausgabe()

