#! /usr/bin/env python3
# -*- coding: utf-8 -*-
#
# Dieses Dokument ist in der Zusammenarbeit von Informatikreferendaren und
# ehemaligen Informatikreferendaren der Studienseminare (heute ZfsL) Arnsberg,
# Hamm und Solingen entstanden.
#
# Das Dokument steht unter der Lizenz: Creative Commons by-nc-sa Version 4.0
# http://creativecommons.org/licenses/by-nc-sa/4.0/deed.de
#
# Nach dieser Lizenz darf das Dokument beliebig kopiert und bearbeitet werden,
# sofern das Folgeprodukt wiederum unter gleichen Lizenzbedingungen vertrieben
# und auf die ursprünglichen Urheber verwiesen wird.
# Eine kommerzielle Nutzung ist ausdrücklich ausgeschlossen.
#
# Die Namensnennung durch einen Verweis und die Lizenzangabe der ursprünglichen
# Urheber auf den Materialien für Schülerinnen und Schüler ist erforderlich.
#
# Die Sammlung der Dokumente steht unter
# http://ddi.uni-wuppertal.de/material/materialsammlung/
# zur Verfügung.
#
# Weitere Lizenz: GPL V3.0
# Siehe http://www.gnu.org/licenses/gpl-3.0.html
#
# $Id: datenstrukturen.py 1248 2015-06-07 16:44:36Z humbert $
#
# Zur Nutzung ist die Zeile
# from datenstrukturen import Liste [, ...] 
# in das Programm aufzunehmen, das die Klasse Liste 
# verwendet. 
#
# Kompatibilität mit Python Version 2.x
from __future__ import print_function
#

class Liste:
	def __init__(self):
		self.__list = list() # <type 'list'>

	def fuegeEinAnPosition(self, position, element):
		self.__list.insert(position, element)

	def gibElementAnPosition(self, position):
		return self.__list[position]

	def haengeAn(self, element):
		self.__list.append(element)

	def entferne(self, element):
		self.__list.remove(element)

	def entferneAnPosition(self, position):
		if position >= len(self.__list):
			print("Fehler: Es existiert kein ",end="") 
			print(str(position) + ". Element in dieser Liste.")
		else:
			self.__list[position:position+1] = []

	def istEnthalten(self, element):
		return element in self.__list

	def gibLaenge(self):
		return len(self.__list)

	def istLeer(self):
		return len(self.__list) == 0

	def fuerAlleDurchfuehren(self, aktion):
		for elem in self.__list:
			ak=aktion + "(elem) "
			exec( "print("+ ak +")" ) 

	def anzeigen(self):
		print (self.__list)

	def __repr__(self):
		return repr(self.__list)

# [Selbst-]Test der Funktionalitäten
if __name__ == "__main__":
	# Klasse Liste:
	testListe = Liste()
	testListe.anzeigen()
	testListe.haengeAn("Dies")
	testListe.anzeigen()
	testListe.haengeAn("ist")
	testListe.anzeigen()
	testListe.haengeAn("ein")
	testListe.anzeigen()
	testListe.haengeAn("Test")
	testListe.anzeigen()
	testListe.entferneAnPosition(1)
	testListe.anzeigen()
	testListe.entferneAnPosition(9)
	testListe.anzeigen()
	if testListe.istEnthalten("Test"):
		testListe.entferne("Test")
		testListe.anzeigen()
	testListe.fuerAlleDurchfuehren("len")
	
