#! /usr/bin/env python3
# -*- coding: utf-8 -*-
#
# Dieses Dokument ist in der Zusammenarbeit von Informatikreferendaren und
# ehemaligen Informatikreferendaren der Studienseminare (heute ZfsL) Arnsberg,
# Hamm und Solingen entstanden.
#
# Das Dokument steht unter der Lizenz: Creative Commons by-nc-sa Version 4.0
# http://creativecommons.org/licenses/by-nc-sa/4.0/deed.de
#
# Nach dieser Lizenz darf das Dokument beliebig kopiert und bearbeitet werden,
# sofern das Folgeprodukt wiederum unter gleichen Lizenzbedingungen vertrieben
# und auf die ursprünglichen Urheber verwiesen wird.
# Eine kommerzielle Nutzung ist ausdrücklich ausgeschlossen.
#
# Die Namensnennung durch einen Verweis und die Lizenzangabe der ursprünglichen
# Urheber auf den Materialien für Schülerinnen und Schüler ist erforderlich.
#
# Die Sammlung der Dokumente steht unter
# http://ddi.uni-wuppertal.de/material/materialsammlung/
# zur Verfügung.
#
# Weitere Lizenz: GPL V3.0
# Siehe http://www.gnu.org/licenses/gpl-3.0.html
#
# $Id: liste.py 1478 2016-04-11 15:57:22Z humbert $
#
# Zur Nutzung ist die Zeile
# from datenstrukturen import Liste [, ...] 
# in das Programm aufzunehmen, das die Klasse Liste 
# verwendet. 
#
# Kompatibilität mit Python Version 2.x
from __future__ import print_function
#

class List:
	def __init__(self):
		self.__list= list() # <class 'list'>
		self.__aktuell= None
		self.__next= None
		self.__hasAccess= False

	def isEmpty(self) -> bool:
		return len(self.__list) == 0
		
	def hasAccess(self) -> bool:
	  return self.__hasAccess

	def next(self):
	  if not self.isEmpty() and self.hasAccess():
	    self.__aktuell= self.__aktuell.__next

	def toFirst(self):
	  if self.isEmpty(): 
	    return
	  else:
	    self.__aktuell= self.__list[0]
 
	def toLast(self):
	  if self.isEmpty(): 
	    return
	  else:
	    self.__aktuell= self.__list[:-1]

	def getContent(self) ->  'ContentType':
	  if self.hasAccess():
	    return self.__aktuell
	  else:
	    return None  

	def setContent(self, content:'ContentType'):
	  if self.hasAccess() and content != None:
	    self.__aktuell= content

	def append(self, element: 'ContentType'):
	  if content != None:
	    self.__list.append(element)

	def insert(self, element: 'ContentType'):
	  if self.hasAccess():
	    self.__list.insert[0,element] 	     

	def concat(self, liste: 'List'):
	  if liste == None or liste.isEmpty():
	    return
	  else:
	    self.__list.concat(liste)        

	def remove(self):
	  if not self.hasAccess() or self.__aktuell is None:
	    return
	  else:
	    help= self.__aktuell.__next
	    self.__list.remove(self.__aktuell)
	    self.__aktuell= help



	def __repr__(self):
	  aktu=if self.__aktuell is None "None"
		return repr(self.__list, aktu)

# [Selbst-]Test der Funktionalitäten
if __name__ == "__main__":
	# Klasse Liste:
	testListe = List()
	print("testListe:", testListe)
	#,testListe.__aktuell,testListe.__next,testListe.__hasAccess)

